SystemOrganization addCategory: #'PharoBot-Core'!

!Point class methodsFor: '*pharobot-core' stamp: 'FacundoMainere 4/13/2012 13:02'!
r: t1 theta: t2
	^ (t1 * t2 sin) negated @  (t1 * t2 cos) negated! !

Workspace subclass: #PharoBotWorkspaceModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

Object subclass: #Bateria
	instanceVariableNames: 'carga'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!Bateria class methodsFor: 'instance creation' stamp: 'FacundoMainere 4/5/2012 19:54'!
new

^super new initialize
! !

!Bateria methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 19:24'!
carga
	^ carga! !

!Bateria methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 19:24'!
carga: anObject
	carga := anObject! !

!Bateria methodsFor: 'operations' stamp: 'FacundoMainere 4/7/2012 17:15'!
cargate

self carga: 1000! !

!Bateria methodsFor: 'operations' stamp: 'FacundoMainere 4/5/2012 20:02'!
consumir: unaCantidad

self carga: self carga - unaCantidad! !

!Bateria methodsFor: 'init' stamp: 'FacundoMainere 4/7/2012 17:15'!
initialize
	self carga: 1000.
	^ self! !

!Bateria methodsFor: 'operations' stamp: 'FacundoMainere 4/7/2012 13:16'!
puedeConsumir: unaCantidad

^self carga >= unaCantidad.! !

Object subclass: #Camino
	instanceVariableNames: 'puntos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!Camino class methodsFor: 'instance creation' stamp: 'FacundoMainere 4/5/2012 20:14'!
new: unPunto
	^ super new initialize: unPunto! !

!Camino methodsFor: 'operaciones' stamp: 'FacundoMainere 2/13/2012 13:04'!
agregarPunto:unPunto

self puntos add: unPunto! !

!Camino methodsFor: 'init' stamp: 'FacundoMainere 4/5/2012 20:13'!
initialize: unPunto
	self puntos: OrderedCollection new.
	self puntos add: unPunto.
	^ self! !

!Camino methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 20:12'!
puntos
	^ puntos! !

!Camino methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 20:12'!
puntos: anObject
	puntos := anObject! !

Object subclass: #EstadoRobot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!EstadoRobot methodsFor: 'operations' stamp: 'FacundoMainere 4/7/2012 12:26'!
bajarPincel 

^self subclassResponsibility 
! !

!EstadoRobot methodsFor: 'operations' stamp: 'FacundoMainere 4/7/2012 12:27'!
estaAbajo

^self subclassResponsibility 
! !

!EstadoRobot methodsFor: 'operations' stamp: 'FacundoMainere 4/7/2012 12:26'!
estaArriba 

^self subclassResponsibility 
! !

!EstadoRobot methodsFor: 'operations' stamp: 'FacundoMainere 4/7/2012 12:27'!
mover: unaDistancia alRobot: unRobot
	^ self subclassResponsibility! !

!EstadoRobot methodsFor: 'operations' stamp: 'FacundoMainere 4/7/2012 12:26'!
subirPincel 

^self subclassResponsibility 
! !

EstadoRobot subclass: #PincelAbajo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!PincelAbajo methodsFor: 'operations' stamp: 'FacundoMainere 2/13/2012 13:00'!
bajarPincel 

^self! !

!PincelAbajo methodsFor: 'operations' stamp: 'FacundoMainere 2/13/2012 13:02'!
estaAbajo

^true! !

!PincelAbajo methodsFor: 'operations' stamp: 'FacundoMainere 2/13/2012 13:02'!
estaArriba

^false! !

!PincelAbajo methodsFor: 'operations' stamp: 'FacundoMainere 4/7/2012 12:57'!
mover: unaDistancia alRobot: unRobot
	unRobot
		posicion:
			(unRobot posicion + (Point r: unaDistancia theta: Float pi / 180 * (unRobot direccion negated - 90))) rounded.
	unRobot caminoActual agregarPunto: unRobot posicion! !

!PincelAbajo methodsFor: 'operations' stamp: 'FacundoMainere 2/13/2012 13:00'!
subirPincel

^PincelArriba new.! !

EstadoRobot subclass: #PincelArriba
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!PincelArriba methodsFor: 'operations' stamp: 'FacundoMainere 2/13/2012 12:59'!
bajarPincel

^PincelAbajo new.! !

!PincelArriba methodsFor: 'operations' stamp: 'FacundoMainere 4/5/2012 20:01'!
estaAbajo

^false! !

!PincelArriba methodsFor: 'operations' stamp: 'FacundoMainere 4/5/2012 20:01'!
estaArriba

^true! !

!PincelArriba methodsFor: 'operations' stamp: 'FacundoMainere 4/7/2012 16:07'!
mover: unaDistancia alRobot: unRobot
	unRobot
		posicion:
			(unRobot posicion + (Point r: unaDistancia theta: Float pi / 180 * (unRobot direccion negated- 90))) rounded.
! !

!PincelArriba methodsFor: 'operations' stamp: 'FacundoMainere 2/13/2012 12:59'!
subirPincel

^self! !

Object subclass: #MundoRobot
	instanceVariableNames: 'robots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!MundoRobot methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 19:56'!
robots
	^ robots! !

!MundoRobot methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 19:56'!
robots: anObject
	robots := anObject! !

Object subclass: #PharoBotEnvironment
	instanceVariableNames: 'workspaces'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!PharoBotEnvironment commentStamp: 'NahuelGarbezza 4/7/2012 17:49' prior: 0!
Contiene configuraciones basicas para iniciar un entorno de PharoBot, como por ejemplo los workspaces.!

!PharoBotEnvironment methodsFor: 'actions' stamp: 'NahuelGarbezza 4/7/2012 17:31'!
addWorkspace: aWorkspace

	self workspaces add: aWorkspace! !

!PharoBotEnvironment methodsFor: 'constants' stamp: 'NahuelGarbezza 4/7/2012 17:32'!
defaultVariableBindings

	^{}! !

!PharoBotEnvironment methodsFor: 'initialize-release' stamp: 'NahuelGarbezza 4/7/2012 17:31'!
initialize

	workspaces := OrderedCollection with: self startWorkspace.! !

!PharoBotEnvironment methodsFor: 'actions' stamp: 'NahuelGarbezza 4/7/2012 17:31'!
removeWorkspace: aWorkspace

	self workspaces remove: aWorkspace! !

!PharoBotEnvironment methodsFor: 'constants' stamp: 'NahuelGarbezza 4/8/2012 12:21'!
robotClass

	^Robot! !

!PharoBotEnvironment methodsFor: 'constants' stamp: 'NahuelGarbezza 4/8/2012 12:21'!
robotMethods

	"Reemplazar por los metodos de la clase Robot que se quieran mostrar"
	^self robotClass selectors! !

!PharoBotEnvironment methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 09:16'!
workspaces

	^workspaces! !

PharoBotEnvironment subclass: #PharoBotEnvironmentWithClasses
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!PharoBotEnvironmentWithClasses commentStamp: 'NahuelGarbezza 4/7/2012 17:49' prior: 0!
Extension a PharoBotEnvironment que permite manejar clases en el entorno.!

!PharoBotEnvironmentWithClasses methodsFor: 'actions' stamp: 'NahuelGarbezza 2/27/2012 11:08'!
addClass: aClass

	self classes add: aClass! !

!PharoBotEnvironmentWithClasses methodsFor: 'accessing' stamp: 'NahuelGarbezza 2/27/2012 11:12'!
classes

	^classes! !

!PharoBotEnvironmentWithClasses methodsFor: 'actions' stamp: 'NahuelGarbezza 2/27/2012 11:08'!
exportClassTo: aFileName
	
	self shouldBeImplemented.! !

!PharoBotEnvironmentWithClasses methodsFor: 'actions' stamp: 'NahuelGarbezza 2/27/2012 11:08'!
importClassFrom: aFileName
	
	self shouldBeImplemented.
	"Llamar a addClass:"! !

!PharoBotEnvironmentWithClasses methodsFor: 'initialize-release' stamp: 'NahuelGarbezza 2/27/2012 11:13'!
initialize

	super initialize.
	classes := OrderedCollection with: self robotClass! !

!PharoBotEnvironmentWithClasses methodsFor: 'actions' stamp: 'NahuelGarbezza 2/27/2012 11:08'!
removeClass: aClass

	self classes remove: aClass! !

!PharoBotEnvironmentWithClasses methodsFor: 'accessing' stamp: 'NahuelGarbezza 2/27/2012 11:14'!
startWorkspace

	^PharoBotWorkspace new
		title: 'Bienvenido a PharoBot - Clase 2';
		content:'"Bienvenido a PharoBot - Clase 2"';
		variableBindings: self defaultVariableBindings asDictionary;
		yourself! !

PharoBotEnvironment subclass: #PharoBotEnvironmentWithObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!PharoBotEnvironmentWithObjects methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/7/2012 17:50'!
defaultVariableBindings

	^{ #robotech -> self robotClass new }! !

!PharoBotEnvironmentWithObjects methodsFor: 'constants' stamp: 'NahuelGarbezza 2/27/2012 11:14'!
startWorkspace

	^PharoBotWorkspace new
		title: 'Bienvenido a PharoBot - Clase 1';
		content:
'
"Bienvenido a PharoBot - Clase 1"

robotech mover: 100.
robotech norte.

etc, etc, etc...
';
	variableBindings: self defaultVariableBindings asDictionary;
	yourself! !

Object subclass: #PharoBotWorkspace
	instanceVariableNames: 'title content variableBindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!PharoBotWorkspace methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/7/2012 17:29'!
content

	^content! !

!PharoBotWorkspace methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/7/2012 17:29'!
content: anObject

	content := anObject! !

!PharoBotWorkspace methodsFor: 'initialize-release' stamp: 'NahuelGarbezza 2/11/2012 17:08'!
initialize

	variableBindings := Dictionary new.! !

!PharoBotWorkspace methodsFor: 'printing' stamp: 'NahuelGarbezza 2/11/2012 17:04'!
printOn: aStream

	aStream << self title! !

!PharoBotWorkspace methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/7/2012 17:29'!
title

	^title! !

!PharoBotWorkspace methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/7/2012 17:29'!
title: anObject

	title := anObject! !

!PharoBotWorkspace methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/7/2012 17:29'!
variableBindings

	^variableBindings! !

!PharoBotWorkspace methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/7/2012 17:29'!
variableBindings: anObject

	variableBindings := anObject! !

Object subclass: #Robot
	instanceVariableNames: 'posicion estado direccion color caminos bateria'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!Robot class methodsFor: 'instance creation' stamp: 'FacundoMainere 4/5/2012 20:04'!
new

^super new initialize.! !

!Robot methodsFor: 'operations' stamp: 'FacundoMainere 4/7/2012 16:58'!
bajarPincel
	self pincelEstaArriba
		ifTrue: [ 
			self caminoActual: (Camino new:self posicion).
			self caminos add: self caminoActual ].
	self estado: estado bajarPincel! !

!Robot methodsFor: 'accessing' stamp: 'FacundoMainere 4/7/2012 13:10'!
bateria
	^ bateria! !

!Robot methodsFor: 'accessing' stamp: 'FacundoMainere 4/7/2012 13:10'!
bateria: anObject
	bateria := anObject! !

!Robot methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 20:00'!
caminoActual
	^ caminoActual! !

!Robot methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 20:00'!
caminoActual: anObject
	caminoActual := anObject! !

!Robot methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 20:00'!
caminos
	^ caminos! !

!Robot methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 20:00'!
caminos: anObject
	caminos := anObject! !

!Robot methodsFor: 'operations' stamp: 'FacundoMainere 4/7/2012 13:10'!
cargarBateria

self bateria cargate! !

!Robot methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 20:00'!
color
	^ color! !

!Robot methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 20:00'!
color: anObject
	color := anObject! !

!Robot methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 20:00'!
direccion
	^ direccion! !

!Robot methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 20:00'!
direccion: anObject
	direccion := anObject! !

!Robot methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 20:00'!
estado
	^ estado! !

!Robot methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 20:00'!
estado: anObject
	estado := anObject! !

!Robot methodsFor: 'init' stamp: 'FacundoMainere 4/7/2012 16:54'!
initialize

self bateria: Bateria new.
self color: Color random.
self posicion: 0@0.
self estado: PincelArriba new.
self direccion: 90.
self caminos: OrderedCollection new.
^self.! !

!Robot methodsFor: 'operations' stamp: 'FacundoMainere 4/7/2012 13:18'!
limpiarCaminos
	self caminoActual: (Camino new: self posicion).
	self caminos: OrderedCollection new.
	self caminos add: caminoActual! !

!Robot methodsFor: 'operations' stamp: 'FacundoMainere 4/7/2012 13:15'!
mover: unaDistancia

(self bateria puedeConsumir:unaDistancia) ifTrue:[
	self estado mover: unaDistancia alRobot: self] ifFalse:[self error: '!!No hay suficiente bateria!!'].

self bateria consumir: unaDistancia.! !

!Robot methodsFor: 'operations' stamp: 'FacundoMainere 4/6/2012 00:00'!
pincelEstaAbajo
	^ self estado estaAbajo! !

!Robot methodsFor: 'operations' stamp: 'FacundoMainere 4/6/2012 00:00'!
pincelEstaArriba
	^ self estado estaArriba! !

!Robot methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 20:00'!
posicion
	^ posicion! !

!Robot methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 20:00'!
posicion: anObject
	posicion := anObject! !

!Robot methodsFor: 'operations' stamp: 'FacundoMainere 4/7/2012 16:59'!
subirPincel

self estado: estado subirPincel! !
